/* Intel Pentium-4 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000, 2001, 2002, 2003, 2004, 2005, 2006 Free
Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA 02110-1301, USA. */

#define BITS_PER_MP_LIMB 32
#define BYTES_PER_MP_LIMB 4


/* 2800 MHz Pentium 4 model 3 */

/* Generated by tuneup.c, 2006-03-21, gcc 3.4 */

#define MUL_KARATSUBA_THRESHOLD          23
#define MUL_TOOM3_THRESHOLD             137

#define SQR_BASECASE_THRESHOLD            0  /* always (native) */
#define SQR_KARATSUBA_THRESHOLD          62
#define SQR_TOOM3_THRESHOLD             161

#define MULLOW_BASECASE_THRESHOLD         8
#define MULLOW_DC_THRESHOLD              52
#define MULLOW_MUL_N_THRESHOLD          470

#define DIV_SB_PREINV_THRESHOLD       MP_SIZE_T_MAX  /* never */
#define DIV_DC_THRESHOLD                 48
#define POWM_THRESHOLD                  134

#define GCD_ACCEL_THRESHOLD               8
#define GCDEXT_THRESHOLD                 56
#define JACOBI_BASE_METHOD                1

#define USE_PREINV_DIVREM_1               1  /* native */
#define USE_PREINV_MOD_1                  1  /* native */
#define DIVREM_2_THRESHOLD                7
#define DIVEXACT_1_THRESHOLD              0  /* always (native) */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always (native) */

#define GET_STR_DC_THRESHOLD             20
#define GET_STR_PRECOMPUTE_THRESHOLD     32
#define SET_STR_THRESHOLD              3296

#define MUL_FFT_TABLE  { 592, 928, 2432, 5632, 14336, 40960, 98304, 393216, 1572864, 6291456, 0 }
#define MUL_FFT_MODF_THRESHOLD          608
#define MUL_FFT_THRESHOLD              3840

#define SQR_FFT_TABLE  { 656, 1440, 2688, 6656, 14336, 40960, 163840, 393216, 1572864, 6291456, 0 }
#define SQR_FFT_MODF_THRESHOLD          672
#define SQR_FFT_THRESHOLD              4864
